<?php
// +----------------------------------------------------------------------
// | yershop网店管理系统
// +----------------------------------------------------------------------
// | Copyright (c) 2018 http://www.yershop.com All rights reserved.
// +----------------------------------------------------------------------
// | 版权申明：yershop网店管理系统不是一个自由软件，是贝云网络官方推出的商业源码，严禁在未经许可的情况下
// | 拷贝、复制、传播、使用yershop网店管理系统的任意代码，如有违反，请立即删除，否则您将面临承担相应
// | 法律责任的风险。如果需要取得官方授权，请联系官方http://www.yershop.com
// +----------------------------------------------------------------------
namespace app\admin\controller;
use think\Controller;
use think\Db;
/**
 * 后台积分类型控制器
 */
class ScoreType extends Home{
     /* 积分类型查询首页 */
	public function index(){     
      if($_POST){
			foreach ($_POST as $key=>$value){
				if($value){
					$map[]  = [$key,'like', '%'.$value.'%'];
				 }
			}
        }
        $map=isset($map)?$map:'';
        $res=getLists('ScoreType',$map,10,'id desc',"");
	    $this->assign('res', $res);
		$this->meta_title="积分类型管理";
		$this->assign('meta_title', $this->meta_title);
	    return $this->fetch("scoretype/index"); 
	}


    /* 编辑积分类型 */
	public function edit($id){   
	    if($_POST){
		   $ScoreType = new \app\admin\model\ScoreType;
           $res=$ScoreType->allowField(true)->validate(true)->save($_POST,['id' => $_POST['id']]);
	       if($res){
			   addUserLog("edit_ScoreType",session_uid());
		      $this->success("更新成功！",cookie("__forward__"));
		   }else{
			  $error=$ScoreType->getError()?$ScoreType->getError():"更新失败！";
			  $this->error($error);
		   } 
	   }
	   else{
		 $map['id']=$id;
		 $info=db("ScoreType")->where($map)->find();
	     $this->assign('info', $info);
		
		   cookie("__forward__",input('server.HTTP_REFERER'));
		 $this->meta_title="编辑积分类型";
		 $this->assign('meta_title', $this->meta_title);
	     return $this->fetch("scoretype/edit");
	   }
	}
	 /* 增加积分类型 */
	public function add($id=""){  
	   if($_POST){
		  $ScoreType = new \app\admin\model\ScoreType;
            // 过滤post数组中的非数据表字段数据
          $res=$ScoreType->validate(true)->allowField(true)->save($_POST);
	      if($res){
			  addUserLog("add_ScoreType",session_uid());
		      $this->success("新增成功！",cookie("__forward__"));
		  }else{
			  $error=$ScoreType->getError()?$ScoreType->getError():"新增失败！";
			  $this->error($error);
		  } 
	 }
	  else{
		
		  $this->meta_title="新增积分类型";
		    cookie("__forward__",input('server.HTTP_REFERER'));
		  $this->assign('meta_title', $this->meta_title);
	      return $this->fetch("ScoreType/edit");
	  }
	}
	 public function send(){   
	    $map['type_id']=input("id");
		if(input("id")==1){
			 $this->transport();
		}else{
			
		
		$map["status"]=0;//待发货订单
		$count=db("score_order")->where($map)->count();
        if(!$count){
		   $this->error("无待发货订单");
		}
		$where['type_id']=input("id");
		$where["status"]=1;//未使用兑换码
		$count2=db("score_code")->where($where)->count();
		if($count>$count2){
		   $this->error("兑换码数量不足,缺少".($count-$count2)."张");
		}
		$list=db("score_code")->where($where)->select();
		$data=db("score_order")->where($map)->select();
		$res=0;
		foreach ($list as $key=>$v){         
				   $save["code"]=$v["code"] ;
				  foreach ($data as $k=>$val){
                      $condition["id"]=$val["id"]; 
					  $save["update_time"]=time() ;//发货时间 
					  $save["status"]=1 ;//发货
					  db("score_order")->where($condition)->update($save);
			       } 
				$update["update_time"]=time() ;//使用时间 
			    $update["status"]=2 ;//设置为已使用
				$update["orderId"]=$v["orderId"] ;//订单号
				$update["uid"]=$v["uid"] ;//发放用户id
				$ex["id"]=$v["id"] ;
				db("score_code")->where($ex)->update($update);
               $res=$res+1;
		}
		if($res){
		   $this->success("操作成功！");
		}else{
			 $this->error("操作失败！");
		}
	  }
	}
	
	 public function transport(){   
	    $map["status"]=0;//待发货订单
		$count=db("score_order")->where($map)->count();
       if(!$count){
		   $this->error("无待发货订单");
		}
		$where["status"]=0;//未使用快递数量
		$count2=db("express")->where($where)->count();
		if($count>$count2){
		   $this->error("快递单数量不足,缺少".($count-$count2)."张");
		}
		$list=db("express")->where($where)->select();
		$data=db("score_order")->where($map)->select();
		$res;
		foreach ($list as $key=>$v){ 
			      $ex["id"]=$v["id"] ;
                  $save["express"]=$v["title"] ;
				  $save["express_code"]=$v["code"] ;
				  foreach ($data as $k=>$val){
                      $condition["id"]=$val["id"]; 
					  $save["update_time"]=time() ;//发货时间 
					  $save["status"]=1 ;//发货
					  db("score_order")->where($condition)->update($save);
			       } 
				$update["update_time"]=time() ;//使用时间 
			    $update["status"]=1 ;//设置为已使用
				db("express")->where($ex)->update($update);
         $res=+$key;
		}
		if($res){
		   $this->success("操作成功！");
		}else{
			 $this->error("操作失败！");
		}
	}
	 /* 删除积分类型*/
	public function del(){   
	    $id=input("id");
		if(intval($id)==1){
			 $this->error("不支持删除实物商品！");exit();
		}
	    $map['id']=["in",$id];
		if(!$map["id"]){
			 $this->error("未选择数据！");
		}
		
		$res=db("ScoreType")->where($map)->delete();
		
		if($res){
		   addUserLog("del_ScoreType",session_uid());
		   $this->success("删除成功！");
		}else{
	           $this->error("删除失败！");
		}
	}
	
}
